diff -up -r -x doc PyQt-x11-gpl-snapshot-4.8.2-f2b28c685066/qpy/QtCore/qpycore_qobject_helpers.cpp PyQt-x11-gpl-snapshot-4.8.2-a935ffc263c2/qpy/QtCore/qpycore_qobject_helpers.cpp
--- PyQt-x11-gpl-snapshot-4.8.2-f2b28c685066/qpy/QtCore/qpycore_qobject_helpers.cpp	2010-11-23 04:44:01.000000000 +0100
+++ PyQt-x11-gpl-snapshot-4.8.2-a935ffc263c2/qpy/QtCore/qpycore_qobject_helpers.cpp	2010-11-27 04:43:52.000000000 +0100
@@ -158,11 +158,14 @@ static int qt_metacall_worker(sipSimpleW
 
                     if (var)
                     {
-                        // This tells QMetaProperty::read() to use the new
-                        // contents of the QVariant it provided.
-                        _a[1] = 0;
-
                         ok = prop->pyqtprop_parsed_type->fromPyObject(py, var);
+
+                        // Make sure that _a[0] still points to the QVariant
+                        // data (whose address we may have just changed) so
+                        // that QMetaProperty::read() doesn't try to create a 
+                        // new QVariant.
+                        if (ok)
+                            _a[0] = var->data();
                     }
                     else
                     {

